src/netbox_rps_plugin/urls.py
"""URL definitions"""

from django.urls import path
from netbox.views.generic import ObjectChangeLogView, ObjectJournalView
from netbox_rps_plugin import views, models


urlpatterns = (
    # Mapping
    path("mappings/", views.MappingListView.as_view(), name="mapping_list"),
    path("mappings/add/", views.MappingEditView.as_view(), name="mapping_add"),
    path(
        "mappings/import/", views.MappingBulkImportView.as_view(), name="mapping_import"
    ),
    path(
        "mappings/delete/",
        views.MappingBulkDeleteView.as_view(),
        name="mapping_bulk_delete",
    ),
    path("mappings/<int:pk>/", views.MappingView.as_view(), name="mapping"),
    path(
        "mappings/<int:pk>/edit/", views.MappingEditView.as_view(), name="mapping_edit"
    ),
    path(
        "mappings/<int:pk>/delete/",
        views.MappingDeleteView.as_view(),
        name="mapping_delete",
    ),
    path(
        "mappings/<int:pk>/http-headers/",
        views.MappingHttpHeadersView.as_view(),
        name="mapping_httpheader",
    ),
    path(
        "mappings/<int:pk>/redirect/",
        views.MappingRedirectsView.as_view(),
        name="mapping_redirect",
    ),
    path(
        "mappings/<int:pk>/saml-config/",
        views.MappingSamlConfigView.as_view(),
        name="mapping_samlconfig",
    ),
    path(
        "mappings/<int:pk>/cache-config/",
        views.MappingCacheConfigView.as_view(),
        name="mapping_cacheconfig",
    ),
    path(
        "mappings/<int:pk>/hsts-protocol/",
        views.MappingHstsProtocolView.as_view(),
        name="mapping_hstsprotocol",
    ),
    path(
        "mappings/<int:pk>/acl-denied-source/",
        views.MappingAclDeniedSourceView.as_view(),
        name="mapping_acldeniedsource",
    ),
    path(
        "mappings/<int:pk>/changelog/",
        ObjectChangeLogView.as_view(),
        name="mapping_changelog",
        kwargs={"model": models.Mapping},
    ),
    path(
        "mappings/<int:pk>/journal/",
        ObjectJournalView.as_view(),
        name="mapping_journal",
        kwargs={"model": models.Mapping},
    ),
    # HTTP Headers
    path("http-headers/", views.HttpHeaderListView.as_view(), name="httpheader_list"),
    path(
        "http-headers/add/", views.HttpHeaderEditView.as_view(), name="httpheader_add"
    ),
    path(
        "http-headers/delete/",
        views.HttpHeaderBulkDeleteView.as_view(),
        name="httpheaders_bulk_delete",
    ),
    path("http-headers/<int:pk>/", views.HttpHeaderView.as_view(), name="httpheader"),
    path(
        "http-headers/<int:pk>/edit/",
        views.HttpHeaderEditView.as_view(),
        name="httpheader_edit",
    ),
    path(
        "http-headers/<int:pk>/delete/",
        views.HttpHeaderDeleteView.as_view(),
        name="httpheader_delete",
    ),
    path(
        "http-headers/<int:pk>/changelog/",
        ObjectChangeLogView.as_view(),
        name="httpheader_changelog",
        kwargs={"model": models.HttpHeader},
    ),
    path(
        "http-headers/<int:pk>/journal/",
        ObjectJournalView.as_view(),
        name="httpheader_journal",
        kwargs={"model": models.HttpHeader},
    ),

    # Redirects
    path("redirect/", views.RedirectListView.as_view(), name="redirect_list"),
    path("redirect/add/", views.RedirectEditView.as_view(), name="redirect_add"),
    path("redirect/delete/", views.RedirectBulkDeleteView.as_view(), name="redirects_bulk_delete"),
    path("redirect/<int:pk>/", views.RedirectView.as_view(), name="redirect"),
    path("redirect/<int:pk>/edit/", views.RedirectEditView.as_view(), name="redirect_edit"),
    path("redirect/<int:pk>/delete/", views.RedirectDeleteView.as_view(), name="redirect_delete"),
    path("redirect/<int:pk>/changelog/", ObjectChangeLogView.as_view(), name="redirect_changelog", kwargs={"model": models.Redirect}),
    path("redirect/<int:pk>/journal/", ObjectJournalView.as_view(), name="redirect_journal", kwargs={"model": models.Redirect}),

    # Saml Config
    path(
        "saml-configs/add/", views.SamlConfigEditView.as_view(), name="samlconfig_add"
    ),
    path(
        "saml-configs/<int:pk>/edit/",
        views.SamlConfigEditView.as_view(),
        name="samlconfig_edit",
    ),
    path(
        "saml-configs/<int:pk>/delete/",
        views.SamlConfigDeleteView.as_view(),
        name="samlconfig_delete",
    ),
    # ACLDeniedSource
    path(
        "acldeniedsource/",
        views.AclDeniedSourceListView.as_view(),
        name="acldeniedsource_list",
    ),
    path("acldeniedsource/<int:id>/",
         views.AclDeniedSourceView.as_view(),
         name="acldeniedsource"),
    path(
        "acldeniedsource/add/",
        views.AclDeniedSourceEditView.as_view(),
        name="acldeniedsource_add",
    ),
    path(
        "acldeniedsource/<int:pk>/edit/",
        views.AclDeniedSourceEditView.as_view(),
        name="acldeniedsource_edit",
    ),
    path(
        "acldeniedsource/<int:pk>/delete/",
        views.AclDeniedSourceDeleteView.as_view(),
        name="acldeniedsource_delete",
    ),
    path(
        "acldeniedsource/delete/",
        views.AclDeniedSourceBulkDeleteView.as_view(),
        name="acldeniedsource_bulk_delete",
    ),
    path(
        "acldeniedsource/<int:pk>/changelog/",
        ObjectChangeLogView.as_view(),
        name="acldeniedsource_changelog",
        kwargs={"model": models.AclDeniedSource},
    ),
    # Cache configs
    path("cache-configs/", views.CacheConfigListView.as_view(), name="cacheconfig_list"),
    path(
        "cache-configs/add/", views.CacheConfigEditView.as_view(), name="cacheconfig_add"
    ),
    path(
        "cache-configs/delete/",
        views.CacheConfigBulkDeleteView.as_view(),
        name="cacheconfigs_bulk_delete",
    ),
    path("cache-configs/<int:pk>/", views.CacheConfigView.as_view(), name="cacheconfig"),
    path(
        "cache-configs/<int:pk>/edit/",
        views.CacheConfigEditView.as_view(),
        name="cacheconfig_edit",
    ),
    path(
        "cache-configs/<int:pk>/delete/",
        views.CacheConfigDeleteView.as_view(),
        name="cacheconfig_delete",
    ),
    path(
        "cache-configs/<int:pk>/changelog/",
        ObjectChangeLogView.as_view(),
        name="cacheconfig_changelog",
        kwargs={"model": models.CacheConfig},
    ),
    path(
        "cache-configs/<int:pk>/journal/",
        ObjectJournalView.as_view(),
        name="cacheconfig_journal",
        kwargs={"model": models.CacheConfig},
    ),
    # Hsts Protocol
    path("hsts-protocol/", views.HstsProtocolListView.as_view(), name="hstsprotocol_list"),
    path(
        "hsts-protocol/add/", views.HstsProtocolEditView.as_view(), name="hstsprotocol_add"
    ),
    path(
        "hsts-protocol/delete/",
        views.HstsProtocolBulkDeleteView.as_view(),
        name="hstsprotocols_bulk_delete",
    ),
    path("hsts-protocol/<int:pk>/", views.HstsProtocolView.as_view(), name="hstsprotocol"),
    path(
        "hsts-protocol/<int:pk>/edit/",
        views.HstsProtocolEditView.as_view(),
        name="hstsprotocol_edit",
    ),
    path(
        "hsts-protocol/<int:pk>/delete/",
        views.HstsProtocolDeleteView.as_view(),
        name="hstsprotocol_delete",
    ),
    path(
        "hsts-protocol/<int:pk>/changelog/",
        ObjectChangeLogView.as_view(),
        name="hstsprotocol_changelog",
        kwargs={"model": models.HstsProtocol},
    ),
    path(
        "hsts-protocol/<int:pk>/journal/",
        ObjectJournalView.as_view(),
        name="hstsprotocol_journal",
        kwargs={"model": models.HstsProtocol},
    ),

)

src/netbox_rps_plugin/models.py
"""Models definitions"""

from typing import Any
from datetime import datetime
from urllib.parse import urlparse
from django.core.exceptions import ValidationError  # pylint: disable=import-error
from django.conf import settings
from django.db import models  # pylint: disable=import-error
from django.db.models import Model, Q  # pylint: disable=import-error
from django.urls import reverse  # pylint: disable=import-error
from django.core.validators import (
    URLValidator,
    MaxValueValidator,
    MinValueValidator,
)  # pylint: disable=import-error
from django.contrib.postgres.fields.array import (
    ArrayField,
)  # pylint: disable=import-error
from netbox.models import NetBoxModel  # pylint: disable=import-error, no-name-in-module
from utilities.choices import (
    ChoiceSet,
)  # pylint: disable=import-error, wrong-import-order
from netfields import InetAddressField

URL_MAX_SIZE = 2000
DEFAULT_SORRY_PAGE = settings.PLUGINS_CONFIG["netbox_rps_plugin"]["default_sorry_page"]


def clean_url(raw_url):
    """Clean an URL"""

    o = urlparse(raw_url)

    credential = ":".join(
        tuple(filter(lambda item: item is not None, (o.username, o.password)))
    )

    hostname = o.hostname if o.port is None else ":".join((o.hostname, str(o.port)))

    return (
        o._replace(netloc=hostname)
        if len(credential) == 0
        else o._replace(netloc="@".join((credential, hostname)))
    ).geturl()


class FilteredURLField(models.URLField):
    """URLField definition class"""

    def clean(self, value: Any, model_instance: Model | None) -> Any:
        """Clean Field value"""

        return clean_url(super().clean(value, model_instance))


class MaxBodyChoices(ChoiceSet):
    """Client max body size choices definition class"""

    key = "Mapping.client_max_body_size"

    DEFAULT_VALUE = 128

    CHOICES = [
        (1, "1", "blue"),
        (128, "128", "blue"),
        (512, "512", "blue"),
        (1024, "1024", "blue"),
        (2048, "2048", "blue"),
    ]


class AuthenticationChoices(ChoiceSet):
    """Authentication choices definition class"""

    key = "Mapping.authentication"

    DEFAULT_VALUE = "none"

    CHOICES = [
        ("none", "None", "dark"),
        ("ldap", "Ldap", "blue"),
        ("ecas", "Ecas", "blue"),
    ]


class ExtensionChoices(ChoiceSet):
    """Extension choices definition class"""

    key = "CacheConfig.list_extensions"

    CHOICES = [
        ("JPG", "JPG"),
        ("GIF", "GIF"),
        ("CSS", "CSS"),
        ("HTML", "HTML"),
        ("JS", "JS"),
        ("XML", "XML"),
    ]


class ApplyToChoices(ChoiceSet):
    """Apply to choices definition class"""

    key = "HttpHeader.applyTo"

    DEFAULT_VALUE = "request"

    CHOICES = [
        ("request", "Request", "blue"),
        ("response", "Response", "red"),
    ]


class RedirectTypeChoices(ChoiceSet):
    """Redirect type definition class"""

    key = "Redirect.redirect_type"

    DEFAULT_VALUE = "1-1"

    CHOICES = [
        ('1-1', 'One to One - Single page to single page'),
        ('N-N', 'Many to Many - Many pages to many pages behind context path'),
        ('N-1', 'Many to One - Many pages behind context path to a single page'),
    ]


class ExtraProtocolChoices(ChoiceSet):
    """Protocol choices definition class"""

    key = "Mapping.protocol"

    WEBSOCKET_SECURE = "websocket"

    CHOICES = [
        (WEBSOCKET_SECURE, "Websocket", "blue"),
    ]


# Info: No longer in use since last requirements, to be confirmed before delete-it completely.
# class ProxyBufferChoices(ChoiceSet):
#     """Proxy Buffer Selection definition class"""

#     key = "Mapping.proxyBufferSize"

#     DEFAULT_VALUE=4

#     CHOICES = [
#         (4, "4", "dark"),
#         (32, "32", "blue"),
#         (64, "64", "blue"),
#         (128, "128", "blue"),
#     ]


def default_protocol():
    """Return the default protocols"""
    return []


class Mapping(NetBoxModel):
    """Mapping definition class"""

    source = FilteredURLField(
        max_length=URL_MAX_SIZE,
        blank=False,
        verbose_name="Source",
        validators=[URLValidator(schemes=["http", "https"])],
        unique=True,
    )
    target = FilteredURLField(
        max_length=URL_MAX_SIZE,
        blank=False,
        verbose_name="Target",
        validators=[URLValidator(schemes=["http", "https"])],
    )
    authentication = models.CharField(
        max_length=30,
        choices=AuthenticationChoices,
        default=AuthenticationChoices.DEFAULT_VALUE,
        blank=False,
        verbose_name="Auth",
    )
    testingpage = models.CharField(
        max_length=URL_MAX_SIZE,
        blank=True,
        null=True,
    )
    webdav = models.BooleanField(
        default=False,
    )
    Comment = models.CharField(max_length=500, blank=True)
    gzip_proxied = models.BooleanField(default=False)
    keepalive_requests = models.IntegerField(
        default=1000, validators=[MinValueValidator(100), MaxValueValidator(5000)]
    )
    keepalive_timeout = models.IntegerField(
        default=75, validators=[MinValueValidator(1), MaxValueValidator(300)]
    )
    proxy_cache = models.BooleanField(default=False)
    proxy_read_timeout = models.IntegerField(
        default=60, validators=[MinValueValidator(1), MaxValueValidator(300)]
    )
    client_max_body_size = models.IntegerField(
        choices=MaxBodyChoices,
        default=MaxBodyChoices.DEFAULT_VALUE,
    )
    sorry_page = models.URLField(
        max_length=URL_MAX_SIZE,
        blank=False,
        verbose_name="Sorry Page",
        validators=[URLValidator(schemes=["http", "https"])],
        default=DEFAULT_SORRY_PAGE,
    )
    extra_protocols = ArrayField(
        base_field=models.CharField(max_length=32, choices=ExtraProtocolChoices),
        null=False,
        blank=True,
        verbose_name="Extra Protocols",
        default=default_protocol,
    )

    proxy_buffer_size = models.IntegerField(
        default=4,
        validators=[MinValueValidator(4), MaxValueValidator(128)],
        blank=True,
        null=True,
        # choices=ProxyBufferChoices,
    )
    # Info : Will be (x4) proxy_buffer_size
    proxy_buffer = models.IntegerField(
        default=16,
        validators=[MinValueValidator(16), MaxValueValidator(512)],
        blank=True,
        null=True,
    )
    # Info : Will be (x2) proxy_buffer_size
    proxy_busy_buffer = models.IntegerField(
        default=8,
        validators=[MinValueValidator(8), MaxValueValidator(256)],
        blank=True,
        null=True,
    )

    proxy_buffer_responses = models.BooleanField(default=True)

    proxy_buffer_requests = models.BooleanField(default=True)

    class Meta:
        """Meta class"""

        ordering = ("source", "target")
        constraints = [
            models.CheckConstraint(
                check=~models.Q(source__exact=models.F("target")),
                name="%(app_label)s_%(class)s_check_target_source_url",
            )
        ]

    def __str__(self):
        return str(self.source)

    def get_absolute_url(self):
        """override"""
        return reverse("plugins:netbox_rps_plugin:mapping", args=[self.pk])

    def clean(self):
        """Clean model method for validation"""
        super().clean()

        if self.source == self.target:
            raise ValidationError(
                {"target": "Target URL cannot be equal to source URL."}
            )


class SamlConfig(NetBoxModel):
    """SAML config definition class"""

    acs_url = models.CharField(
        max_length=URL_MAX_SIZE,
        blank=False,
        verbose_name="ACS URL",
        validators=[URLValidator(message="It must be a url")],
    )
    logout_url = models.CharField(
        max_length=URL_MAX_SIZE,
        blank=False,
        verbose_name="Logout URL",
        validators=[URLValidator(message="It must be a url")],
    )
    force_nauth = models.BooleanField(
        default=False,
    )
    Mapping = models.OneToOneField(
        Mapping,
        on_delete=models.CASCADE,
        related_name="saml_config",
        db_column="mapping_id",
        name="mapping",
    )


class HttpHeader(NetBoxModel):
    """HTTP Header definition class"""

    mapping = models.ForeignKey(
        Mapping, on_delete=models.CASCADE, related_name="http_headers"
    )
    name = models.CharField(max_length=120, blank=False, verbose_name="Header name")
    value = models.CharField(
        max_length=256, null=True, blank=True, verbose_name="Header value"
    )
    apply_to = models.CharField(
        max_length=30,
        choices=ApplyToChoices,
        default=ApplyToChoices.DEFAULT_VALUE,
        blank=False,
        verbose_name="Apply to",
    )

    class Meta:
        """Meta class"""

        unique_together = ["mapping", "name", "apply_to"]
        ordering = ["name"]

    def __str__(self):
        return str(self.name)

    def get_absolute_url(self):
        """override"""
        return reverse("plugins:netbox_rps_plugin:httpheader", args=[self.pk])


class Redirect(NetBoxModel):
    """Redirect definition class"""

    id = models.AutoField(primary_key=True) # Big (8 byte) integer, Unique ID
    mapping = models.ForeignKey(
        Mapping, on_delete=models.CASCADE, related_name="redirects"
    )

    source = models.CharField(max_length=2000, blank=False)  # String up to 2000 characters
    target = models.CharField(max_length=2000, blank=False)  # String up to 2000 characters

    redirect_type = models.CharField(
        blank=False,
        max_length=3,
        choices=RedirectTypeChoices,
        default=RedirectTypeChoices.DEFAULT_VALUE,
    ) # Array of string, limited values

    activation_date = models.DateTimeField(default=datetime.now)  # Datetime, default is now
    deactivation_date = models.DateTimeField(null=True, blank=True)  # Datetime, can be null

    class Meta:
        """Meta class"""
        constraints = [
            models.CheckConstraint(

src/netbox_rps_plugin/templates/netbox_rps_plugin/acldeniedsource.html
{% extends 'generic/object.html' %}

{% block content %}
<div class="row mb-3">
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">Acl Denied Source</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">ID</th>
            <td>{{ object.id }}</td>
          </tr>
          <tr>
            <th scope="row">Mapping ID</th>
            <td>
              {% if object.mapping.id %}
              {{ object.mapping.id }}
              {% else %}
              {{ 'not defined'|placeholder }}
              {% endif %}
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">Details</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">id</th>
            <td>{{ object.id }}</td>
          </tr>
          <tr>
            <th scope="row">Mapping ID</th>
            <td>{{ object.id }}</td>
          </tr>
          <tr>
            <th scope="row">Acl Source</th>
            <td>{{ object.acl_source }}</td>
          </tr>
          <tr>
            <th scope="row">Last Updated</th>
            <td>{{ object.last_updated }}</td>
          </tr>
          <tr>
            <th scope="row">Created</th>
            <td>{{ object.created }}</td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</div>
{% endblock content %}

src/netbox_rps_plugin/templates/netbox_rps_plugin/cacheconfig.html
{% extends 'generic/object.html' %}

{% block content %}
  <div class="row mb-3">
    <div class="col col-md-6">
      <div class="card">
        <h5 class="card-header">HEADERS</h5>
        <div class="card-body">
          <table class="table table-hover attr-table">
            <tr>
              <th scope="row">Mapping</th>
              <td>{{ object.mapping }}</td>
            </tr>
            <tr>
              <th scope="row">List extensions</th>
              <td>{{ object.list_extensions }}</td>
            </tr>
            <tr>
                <th scope="row">TTL</th>
                <td>{{ object.ttl }}</td>
            </tr>
            <tr>
                <th scope="row">Max size limit</th>
                <td>{{ object.max_size_limit }}</td>
            </tr>
            <tr>
                <th scope="row">Created</th>
                <td>{{ object.created }}</td>
            </tr>
            <tr>
                <th scope="row">Last updated</th>
                <td>{{ object.last_updated }}</td>
            </tr>
            </table>
        </div>
      </div>
      {% include 'inc/panels/custom_fields.html' %}
      {% include 'inc/panels/tags.html' %}
    </div>
  </div>
{% endblock content %}

src/netbox_rps_plugin/templates/netbox_rps_plugin/mapping.html
{% extends 'generic/object.html' %}

{% block extra_controls %}
<a href="{% url 'plugins:netbox_rps_plugin:httpheader_add' %}?mapping={{ object.pk }}&return_url={{ object.get_absolute_url }}"
  class="btn btn-sm btn-primary">
  <span class="mdi mdi-plus-thick" aria-hidden="true"></span> Add HTTP Header
</a>

<a href="{% url 'plugins:netbox_rps_plugin:redirect_add' %}?mapping={{ object.pk }}&return_url={{ object.get_absolute_url }}"
  class="btn btn-sm btn-primary">
  <span class="mdi mdi-plus-thick" aria-hidden="true"></span> Add Redirect
</a>

{% if not object.saml_config %}
<a href="{% url 'plugins:netbox_rps_plugin:samlconfig_add' %}?mapping={{ object.pk }}&return_url={{ object.get_absolute_url }}"
  class="btn btn-sm btn-primary">
  <span class="mdi mdi-plus-thick" aria-hidden="true"></span> Add <abbr
    title="Security Assertion Markup Language">SAML</abbr> Configuration
</a>
{% endif %}

<a href="{% url 'plugins:netbox_rps_plugin:acldeniedsource_add' %}?mapping={{ object.pk }}&return_url={{ object.get_absolute_url }}"
  class="btn btn-sm btn-primary">
  <span class="mdi mdi-plus-thick" aria-hidden="true"></span> Add <abbr
    title="Access Control List">ACL</abbr> Denied Source
</a>

{% if not object.cache_config %}
<a href="{% url 'plugins:netbox_rps_plugin:cacheconfig_add' %}?mapping={{ object.pk }}&return_url={{ object.get_absolute_url }}"
  class="btn btn-sm btn-primary">
  <span class="mdi mdi-plus-thick" aria-hidden="true"></span> Add Cache Configuration
</a>
{% endif %}
{% if not object.hsts_protocol %}
<a href="{% url 'plugins:netbox_rps_plugin:hstsprotocol_add' %}?mapping={{ object.pk }}&return_url={{ object.get_absolute_url }}"
  class="btn btn-sm btn-primary">
  <span class="mdi mdi-plus-thick" aria-hidden="true"></span> Add Hsts Protocol
</a>
{% endif %}
{% endblock %}

{% block content %}
<div class="row mb-3">
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">MAPPINGS</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">Name</th>
            <td>{{ object.source }}</td>
          </tr>
          <tr>
            <th scope="row">Comment</th>
            <td>
              {% if object.Comment %}
              {{ object.Comment }}
              {% else %}
              {{ ''|placeholder }}
              {% endif %}
            </td>
          </tr>
        </table>
      </div>
    </div>
    {% include 'inc/panels/custom_fields.html' %}
    {% include 'inc/panels/tags.html' %}
  </div>
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">Details</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">Source</th>
            <td>{{ object.source }}</td>
          </tr>
          <tr>
            <th scope="row">Target</th>
            <td>{{ object.target }}</td>
          </tr>
          <tr>
            <th scope="row">Authentication</th>
            <td>{{ object.get_authentication_display|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">Testing page</th>
            <td>{{ object.testingpage }}</td>
          </tr>
          <tr>
            <th scope="row">Webdav</th>
            <td>{{ object.webdav|yesno }}</td>
          </tr>
          <tr>
            <th scope="row">Extra Protocols</th>
            <td>{{ object.extra_protocols|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">Comment</th>
            <td>
              {% if object.Comment %}
              {{ object.Comment }}
              {% else %}
              {{ ''|placeholder }}
              {% endif %}
            </td>
          </tr>
          <tr>
            <th scope="row">gzip proxied</th>
            <td>{{ object.gzip_proxied|yesno }}</td>
          </tr>
          <tr>
            <th scope="row">Keepalive requests</th>
            <td>{{ object.keepalive_requests }}</td>
          </tr>
          <tr>
            <th scope="row">Keepalive timeout</th>
            <td>{{ object.keepalive_timeout }}&nbsp;s</td>
          </tr>
          <tr>
            <th scope="row">Proxy cache</th>
            <td>{{ object.proxy_cache|yesno }}</td>
          </tr>
          <tr>
            <th scope="row">Proxy read timeout</th>
            <td>{{ object.proxy_read_timeout }}&nbsp;s</td>
          </tr>
          <tr>
            <th scope="row">Client max body size</th>
            <td>{{ object.client_max_body_size }}&nbsp;MB</td>
          </tr>
          <tr>
            <th scope="row">Sorry Page</th>
            <td>{{ object.sorry_page }}</td>
          </tr>
          <tr>
            <th scope="row">Proxy Buffer Size</th>
            <td>{{ object.proxy_buffer_size }}</td>
          </tr>
          <tr>
            <th scope="row">Proxy Buffer</th>
            <td>{{ object.proxy_buffer }}</td>
          </tr>
          <tr>
            <th scope="row">Proxy Busy Buffer</th>
            <td>{{ object.proxy_busy_buffer }}</td>
          </tr>
        </table>
      </div>
    </div>
    {% if object.saml_config %}
    <div class="card">
      <h5 class="card-header">SAML Configuration</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">ACS URL</th>
            <td>{{ object.saml_config.acs_url }}</td>
          </tr>
          <tr>
            <th scope="row">Logout URL</th>
            <td>{{ object.saml_config.logout_url }}</td>
          </tr>
          <tr>
            <th scope="row">Force AuthnRequest</th>
            <td>{{ object.saml_config.force_nauth }}</td>
          </tr>
        </table>
      </div>
    </div>
    {% endif %}
    <!-- {% if object.acl_denied_source %}
    <div class="col col-md-6">
      <div class="card">
        <h5 class="card-header">ACL Denied Source</h5>
        <div class="card-body">
          <table class="table table-hover attr-table">
            <tr>
              <th scope="row">id</th>
              <td>{{ object.acl_denied_source.id }}</td>
            </tr>
            <tr>
              <th scope="row">Mapping ID</th>
              <td>{{ object.id }}</td>
            </tr>
            <tr>
              <th scope="row">Acl Source</th>
              <td>{{ object.acl_denied_source.acl_source }}</td>
            </tr>
            <tr>
              <th scope="row">Last Updated</th>
              <td>{{ object.acl_denied_source.last_updated }}</td>
            </tr>
            <tr>
              <th scope="row">Created</th>
              <td>{{ object.acl_denied_source.created }}</td>
            </tr>
          </table>
        </div>
      </div>
    </div>
    {% endif %} -->
  </div>
</div>
{% endblock content %}